library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity mouse_controller is
  
  port (
    clk        : in  std_logic;
    reset_n    : in  std_logic;
    read       : in  std_logic;
    write      : in  std_logic;
    address    : in  std_logic_vector(3 downto 0);
    readdata   : out std_logic_vector(31 downto 0);
    mousedata  : in  std_logic_vector(31 downto 0);
    writedata  : in  std_logic_vector(31 downto 0);
    mouseIrq   : out std_logic
    );
  
end mouse_controller;

architecture rtl of mouse_controller is

signal left_flag : std_logic_vector(31 downto 0);
signal left_click : std_logic;
signal right_click : std_logic;

begin

  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
			readdata <= (others => '0');
      else
			if ((left_click = '0' and mousedata(0) = '1') or (left_click = '1' and mousedata(0) = '0') 
			or (right_click = '0' and mousedata(1) = '1') or (right_click = '1' and mousedata(1) = '0')) then
				mouseIrq <= '1';
			elsif write = '1' then
				mouseIrq <= '0';
			end if;
			readdata <= mousedata;
			left_click <= mousedata(0);
			right_click <= mousedata(1);
		end if;
	end if;
  end process;

end rtl;
